<?php

class Sitemap
{

	public $id;
	public $smCode;
	public $smFileName;
	public $smPath;
	public $fileType;

	public $customDataStart;
	public $customDataEnd;
	public $changeFreq;
	public $lastMod;
	public $priorSwitch;

	public $editTime;

	public function convertFormData($data)
	{

		$this->smCode = (isset($data['smCode'])) ? $data['smCode'] : '';
		$this->smFileName = (isset($data['smFileName'])) ? $data['smFileName'] : '';
		$this->smPath = (isset($data['smPath'])) ? $data['smPath'] : '';
		$this->fileType = (isset($data['fileType'])) ? $data['fileType'] : 'urlSet';

		$this->customDataStart = (isset($data['customDataStart'])) ? $data['customDataStart'] : '';
		$this->customDataEnd = (isset($data['customDataEnd'])) ? $data['customDataEnd'] : '';
		$this->changeFreq = (isset($data['changeFreq'])) ? $data['changeFreq'] : '';
		$this->lastMod = (isset($data['lastMod'])) ? $data['lastMod'] : '';
		$this->priorSwitch = (isset($data['priorSwitch'])) ? $data['priorSwitch'] : '';

	}

	public function convertDbData($data)
	{

		$this->smCode = $data['smCode'];
		$this->smPath = $data['smPath'];
		$this->smFileName = $data['smFileName'];
		$this->fileType = $data['fileType'];
		$this->changeFreq = $data['changeFreq'];
		$this->lastMod = $data['lastMod'];
		$this->priorSwitch = $data['priorSwitch'];

	}

	public function getXmlCode($sitemap,$contentList)
	{


$indexFileStart = <<<EOD
<?xml version="1.0" encoding="UTF-8"?>
<sitemapindex xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">
EOD;

$indexFileEnd = <<<EOD
</sitemapindex>
EOD;

$urlSetFileStart = <<<EOD
<?xml version="1.0" encoding="utf-8"?>
<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9"
   xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
   xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd">
EOD;

$urlSetFileEnd = <<<EOD
</urlset>
EOD;

		$urlStart = str_replace("https","http",$GLOBALS['baseUrl']);

		$xmlContents="";
		if($sitemap->fileType=="urlSet"){

			$urlSet="";
	
			foreach ($contentList as $item) {

				$urlSet.="<url>\n";

				$urlSet.="<loc>";
				$urlSet.=($urlStart.$item['alias']);
				$urlSet.="</loc>\n";

				if($sitemap->lastMod!="None"){
					$urlSet.="<lastmod>";
					$urlSet.=date("Y-m-d", $item['edited']);
					$urlSet.="</lastmod>\n";
				}

				if($sitemap->changeFreq!="None"){
					$urlSet.="<changefreq>";
					$urlSet.=$sitemap->changeFreq;
					$urlSet.="</changefreq>\n";
				}

				if($sitemap->priorSwitch!="Disabled"){
					$urlSet.="<priority>";
					$urlSet.=$item['priorValue'];
					$urlSet.="</priority>\n";
				}

				$urlSet.="</url>\n";

			}

			$xmlContents.=$urlSetFileStart;
			$xmlContents.="\n";
//			$xmlContents.="\n";
			if($this->customDataStart!=""){
				$xmlContents.=$this->customDataStart;
			}
			if($urlSet!=""){
				$xmlContents.=$urlSet;
			}
			if($this->customDataEnd!=""){
				$xmlContents.=$this->customDataEnd;
			}
			$xmlContents.=$urlSetFileEnd;
		}
		else{

			$xmlContents.=$indexFileStart;
			$xmlContents.="\n";
			if($this->customDataStart!=""){
				$xmlContents.=$this->customDataStart;
			}
			if($this->customDataEnd!=""){
				$xmlContents.=$this->customDataEnd;
			}
			$xmlContents.=$indexFileEnd;
		}

		return $xmlContents;

	}

	public function saveFile($sitemap,$xmlContents)
	{

		$submitMessage="initial";
		$submitMessage="";

		try
		{
			if(file_exists($sitemap->smPath)){
				$filePath=$sitemap->smPath."/".$sitemap->smFileName;
				if (is_writable($sitemap->smPath)){
					$fp=fopen($filePath,'w+');
				   if ( !$fp ) {
						$mesContent="File opening failed.";
						$mesType="problem";
						$submitMessage=$this->getMessage($mesContent,$mesType);
			      }  
					else{
						fwrite($fp, $xmlContents);

						$mesContent="XML file was saved.";
						$mesType="success";
						$submitMessage=$this->getMessage($mesContent,$mesType);
					}
					fclose($fp);
	
	
				} else {
					$mesContent="Directory ".$sitemap->smPath." is not writable.";
					$mesType="problem";
					$submitMessage=$this->getMessage($mesContent,$mesType);
				}
	
			}else{
				$mesContent="Directory ".$sitemap->smPath." does not exist.";
				$mesType="problem";
				$submitMessage=$this->getMessage($mesContent,$mesType);
			}
		} catch ( Exception $e ) {
			$mesContent="Other file writing or managing error.";
			$mesType="problem";
			$submitMessage=$this->getMessage($mesContent,$mesType);
		}

		return $submitMessage;

	}

	public function getMessage($content,$type)
	{

		$message="";

		$mesStartTagP="<div class=\"problem-note\">";
		$mesStartTagS="<div class=\"success-note\">";
		$mesEndTag="</div>";
		if($type=="success"){
			$message="";
			$message.=$mesStartTagS;
			$message.=$content;
			$message.=$mesEndTag;
		}else{
			$message="";
			$message.=$mesStartTagP;
			$message.=$content;
			$message.=$mesEndTag;
		}
		return $message;

	}

}
